

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.visualization.xrbplot &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.visualization.xrbplot</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.visualization.xrbplot</h1><div class="highlight"><pre>
<span></span><span class="ch">#!/usr/bin/env python3</span>
<span class="sd">&quot;&quot;&quot;To plot the X-ray luminosity function of a binary population.</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Nam Tran &lt;tranhn03@gmail.com&gt;&#39;</span>              <span class="p">]</span>

<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>


<div class="viewcode-block" id="get_xlf"><a class="viewcode-back" href="../../../api/posydon.visualization.xrbplot.html#posydon.visualization.xrbplot.get_xlf">[docs]</a><span class="k">def</span> <span class="nf">get_xlf</span><span class="p">(</span><span class="n">Lx</span><span class="p">,</span> <span class="n">beaming</span><span class="p">,</span> <span class="n">L</span><span class="p">,</span> <span class="n">scale</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Construct the X-ray Luminosity Function.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Lx : array_like</span>
<span class="sd">        The luminosities of the stars.</span>
<span class="sd">    beaming : array_like</span>
<span class="sd">        The corresponding beaming factor.</span>
<span class="sd">    L : array_like</span>
<span class="sd">        Contain bools which are used for logical indexing the Luminosity.</span>
<span class="sd">    scale : float</span>
<span class="sd">        A factor that will be multiplied to the number of binaries.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    list of ndarray</span>
<span class="sd">        The x and y values of the XLF.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">Lx</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">asanyarray</span><span class="p">(</span><span class="n">Lx</span><span class="p">)</span>
    <span class="n">L</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">asanyarray</span><span class="p">(</span><span class="n">L</span><span class="p">)</span>

    <span class="n">Lx_new</span> <span class="o">=</span> <span class="n">Lx</span><span class="p">[</span><span class="n">L</span><span class="p">]</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Lx_new</span><span class="p">):</span>
        <span class="n">beam_new</span> <span class="o">=</span> <span class="n">beaming</span><span class="p">[</span><span class="n">L</span><span class="p">]</span>
        <span class="n">n_new</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">cumsum</span><span class="p">(</span><span class="n">beam_new</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">flip</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">argsort</span><span class="p">(</span><span class="n">Lx_new</span><span class="p">))])</span> <span class="o">*</span> <span class="n">scale</span>
        <span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">hstack</span><span class="p">([</span><span class="n">np</span><span class="o">.</span><span class="n">flip</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sort</span><span class="p">(</span><span class="n">Lx_new</span><span class="p">),</span> <span class="mi">0</span><span class="p">),</span> <span class="n">Lx</span><span class="o">.</span><span class="n">min</span><span class="p">()])</span>
        <span class="n">y</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">hstack</span><span class="p">([</span><span class="n">n_new</span><span class="p">,</span> <span class="n">n_new</span><span class="o">.</span><span class="n">max</span><span class="p">()])</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">x</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">y</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">return</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span></div>


<div class="viewcode-block" id="xlf_plot"><a class="viewcode-back" href="../../../api/posydon.visualization.xrbplot.html#posydon.visualization.xrbplot.xlf_plot">[docs]</a><span class="k">def</span> <span class="nf">xlf_plot</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="n">scale</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">ax</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">xylim</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">single</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Plots the X-ray Luminosity function.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    data : ndarray</span>
<span class="sd">        The output from `xrbpop` script.</span>
<span class="sd">    scale : float</span>
<span class="sd">        A factor that will be multiplied to the number of binaries.</span>
<span class="sd">    ax : Axes</span>
<span class="sd">        The axes to plot the XLF.</span>
<span class="sd">    xylim : bool</span>
<span class="sd">        if `False` then no change on the limits will be made otherwise</span>
<span class="sd">        the range of the luminosity will be limited from 1e36 erg/s to at least 1e41 erg/s.</span>
<span class="sd">    single : bool</span>
<span class="sd">        If `False` then</span>
<span class="sd">        the XLF will be splitted in four separate XLFs:</span>
<span class="sd">        Wind-Fed Neutron stars, Wind-Fed Black Holes,</span>
<span class="sd">        RLO neutron stars and RLO black holes.</span>
<span class="sd">        If `True` then only the total XLF will be shown.</span>

<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">if</span> <span class="n">ax</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">axes</span><span class="p">()</span>

    <span class="n">d</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">rec</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">data</span><span class="p">)</span>
    <span class="n">x</span><span class="p">,</span> <span class="n">y</span> <span class="o">=</span> <span class="n">get_xlf</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">Lx</span><span class="p">,</span> <span class="n">d</span><span class="o">.</span><span class="n">weight</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ones_like</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">Lx</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">bool</span><span class="p">),</span> <span class="n">scale</span><span class="p">)</span>

    <span class="k">if</span> <span class="ow">not</span> <span class="n">single</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="s1">&#39;k-&#39;</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Total&#39;</span><span class="p">,</span> <span class="n">zorder</span><span class="o">=-</span><span class="mi">1</span><span class="p">)</span>

        <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="o">*</span><span class="n">get_xlf</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">Lx</span><span class="p">,</span> <span class="n">d</span><span class="o">.</span><span class="n">weight</span><span class="p">,</span> <span class="o">~</span><span class="n">d</span><span class="o">.</span><span class="n">rlo_flag</span> <span class="o">&amp;</span> <span class="n">d</span><span class="o">.</span><span class="n">ns_flag</span><span class="p">,</span> <span class="n">scale</span><span class="p">),</span>
                <span class="s1">&#39;b-&#39;</span><span class="p">,</span>
                <span class="n">label</span><span class="o">=</span><span class="s1">&#39;NS: Wind-Fed&#39;</span><span class="p">,</span>
                <span class="n">zorder</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="o">*</span><span class="n">get_xlf</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">Lx</span><span class="p">,</span> <span class="n">d</span><span class="o">.</span><span class="n">weight</span><span class="p">,</span> <span class="n">d</span><span class="o">.</span><span class="n">rlo_flag</span> <span class="o">&amp;</span> <span class="n">d</span><span class="o">.</span><span class="n">ns_flag</span><span class="p">,</span> <span class="n">scale</span><span class="p">),</span>
                <span class="s1">&#39;b--&#39;</span><span class="p">,</span>
                <span class="n">label</span><span class="o">=</span><span class="s1">&#39;NS: RLO&#39;</span><span class="p">,</span>
                <span class="n">zorder</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="o">*</span><span class="n">get_xlf</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">Lx</span><span class="p">,</span> <span class="n">d</span><span class="o">.</span><span class="n">weight</span><span class="p">,</span> <span class="o">~</span><span class="n">d</span><span class="o">.</span><span class="n">rlo_flag</span> <span class="o">&amp;</span> <span class="o">~</span><span class="n">d</span><span class="o">.</span><span class="n">ns_flag</span><span class="p">,</span> <span class="n">scale</span><span class="p">),</span>
                <span class="s1">&#39;r-&#39;</span><span class="p">,</span>
                <span class="n">label</span><span class="o">=</span><span class="s1">&#39;BH: Wind-Fed&#39;</span><span class="p">,</span>
                <span class="n">zorder</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="o">*</span><span class="n">get_xlf</span><span class="p">(</span><span class="n">d</span><span class="o">.</span><span class="n">Lx</span><span class="p">,</span> <span class="n">d</span><span class="o">.</span><span class="n">weight</span><span class="p">,</span> <span class="n">d</span><span class="o">.</span><span class="n">rlo_flag</span> <span class="o">&amp;</span> <span class="o">~</span><span class="n">d</span><span class="o">.</span><span class="n">ns_flag</span><span class="p">,</span> <span class="n">scale</span><span class="p">),</span>
                <span class="s1">&#39;r--&#39;</span><span class="p">,</span>
                <span class="n">label</span><span class="o">=</span><span class="s1">&#39;BH: RLO&#39;</span><span class="p">,</span>
                <span class="n">zorder</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zorder</span><span class="o">=-</span><span class="mi">1</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">xylim</span><span class="p">:</span>
        <span class="n">min_y</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">y</span><span class="p">),</span> <span class="mf">1e-2</span><span class="p">)</span>
        <span class="n">min_x</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">x</span><span class="p">),</span> <span class="mf">1e36</span><span class="p">)</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">min_x</span><span class="p">,</span> <span class="n">x</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">y</span> <span class="o">&gt;</span> <span class="n">min_y</span><span class="p">)])</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="n">min_y</span><span class="p">,</span> <span class="n">y</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">x</span> <span class="o">&lt;</span> <span class="n">min_x</span><span class="p">)])</span>

    <span class="n">ax</span><span class="o">.</span><span class="n">set_xscale</span><span class="p">(</span><span class="s1">&#39;log&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_yscale</span><span class="p">(</span><span class="s1">&#39;log&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;$N (&gt;L_x)$&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s1">&#39;$L_x$ (erg/s)&#39;</span><span class="p">)</span></div>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>